JUCE: MPESynthesiserBase Struct Reference

JUCE

Public Types | Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
MPESynthesiserBase Struct Referenceabstract
juce_audio_basics » mpe

Derive from this class to create a basic audio generator capable of MPE. More...

`#include <juce_MPESynthesiserBase.h>`

Inheritance diagram for MPESynthesiserBase:

## Public Types
using | TrackingMode = MPEInstrument::TrackingMode

## Public Member Functions
| MPESynthesiserBase ()
| Constructor. More...
| MPESynthesiserBase (MPEInstrument &instrument)
| Constructor. More...
MPEZoneLayout | getZoneLayout () const noexcept
| Returns the synthesiser's internal MPE zone layout. More...
void | setZoneLayout (MPEZoneLayout newLayout)
| Re-sets the synthesiser's internal MPE zone layout to the one passed in. More...
virtual void | setCurrentPlaybackSampleRate (double sampleRate)
| Tells the synthesiser what the sample rate is for the audio it's being used to render. More...
double | getSampleRate () const noexcept
| Returns the current target sample rate at which rendering is being done. More...
template<typename floatType >
void | renderNextBlock (AudioBuffer< floatType > &outputAudio, const MidiBuffer &inputMidi, int startSample, int numSamples)
| Creates the next block of audio output. More...
virtual void | handleMidiEvent (const MidiMessage &)
| Handle incoming MIDI events (called from renderNextBlock). More...
void | setMinimumRenderingSubdivisionSize (int numSamples, bool shouldBeStrict=false) noexcept
| Sets a minimum limit on the size to which audio sub-blocks will be divided when rendering. More...
void | enableLegacyMode (int pitchbendRange=2, Range< int > channelRange=Range< int >(1, 17))
| Puts the synthesiser into legacy mode. More...
bool | isLegacyModeEnabled () const noexcept
| Returns true if the instrument is in legacy mode, false otherwise. More...
Range< int > | getLegacyModeChannelRange () const noexcept
| Returns the range of MIDI channels (1-16) to be used for notes when in legacy mode. More...
void | setLegacyModeChannelRange (Range< int > channelRange)
| Re-sets the range of MIDI channels (1-16) to be used for notes when in legacy mode. More...
int | getLegacyModePitchbendRange () const noexcept
| Returns the pitchbend range in semitones (0-96) to be used for notes when in legacy mode. More...
void | setLegacyModePitchbendRange (int pitchbendRange)
| Re-sets the pitchbend range in semitones (0-96) to be used for notes when in legacy mode. More...
void | setPressureTrackingMode (TrackingMode modeToUse)
| Set the MPE tracking mode for the pressure dimension. More...
void | setPitchbendTrackingMode (TrackingMode modeToUse)
| Set the MPE tracking mode for the pitchbend dimension. More...
void | setTimbreTrackingMode (TrackingMode modeToUse)
| Set the MPE tracking mode for the timbre dimension. More...
Public Member Functions inherited from MPEInstrument::Listener
virtual | ~Listener ()=default
| Destructor. More...
virtual void | noteAdded (MPENote newNote)
| Implement this callback to be informed whenever a new expressive MIDI note is triggered. More...
virtual void | notePressureChanged (MPENote changedNote)
| Implement this callback to be informed whenever a currently playing MPE note's pressure value changes. More...
virtual void | notePitchbendChanged (MPENote changedNote)
| Implement this callback to be informed whenever a currently playing MPE note's pitchbend value changes. More...
virtual void | noteTimbreChanged (MPENote changedNote)
| Implement this callback to be informed whenever a currently playing MPE note's timbre value changes. More...
virtual void | noteKeyStateChanged (MPENote changedNote)
| Implement this callback to be informed whether a currently playing MPE note's key state (whether the key is down and/or the note is sustained) has changed. More...
virtual void | noteReleased (MPENote finishedNote)
| Implement this callback to be informed whenever an MPE note is released (either by a note-off message, or by a sustain/sostenuto pedal release for a note that already received a note-off), and should therefore stop playing. More...
virtual void | zoneLayoutChanged ()
| Implement this callback to be informed whenever the MPE zone layout or legacy mode settings of this instrument have been changed. More...

## Protected Member Functions
virtual void | renderNextSubBlock (AudioBuffer< float > &outputAudio, int startSample, int numSamples)=0
| Implement this method to render your audio inside. More...
virtual void | renderNextSubBlock (AudioBuffer< double > &, int, int)
| Implement this method if you want to render 64-bit audio as well; otherwise leave blank. More...

## Protected Attributes
MPEInstrument & | instrument

## Detailed Description

Derive from this class to create a basic audio generator capable of MPE.

Implement the callbacks of MPEInstrument::Listener (noteAdded, notePressureChanged etc.) to let your audio generator know that MPE notes were triggered, modulated, or released. What to do inside them, and how that influences your audio generator, is up to you!

This class uses an instance of MPEInstrument internally to handle the MPE note state logic.

This class is a very low-level base class for an MPE instrument. If you need something more sophisticated, have a look at MPESynthesiser. This class extends MPESynthesiserBase by adding the concept of voices that can play notes, a voice stealing algorithm, and much more.

See also
  MPESynthesiser, MPEInstrument

## Member Typedef Documentation

## ◆ TrackingMode

using MPESynthesiserBase::TrackingMode = MPEInstrument::TrackingMode

## Constructor & Destructor Documentation

## ◆ MPESynthesiserBase() [1/2]

MPESynthesiserBase::MPESynthesiserBase | ( |  | ) |

Constructor.

## ◆ MPESynthesiserBase() [2/2]

MPESynthesiserBase::MPESynthesiserBase | ( | MPEInstrument & | instrument | ) |

Constructor.

If you use this constructor, the synthesiser will use the provided instrument object to handle the MPE note state logic. This is useful if you want to use an instance of your own class derived from MPEInstrument for the MPE logic.

## Member Function Documentation

## ◆ getZoneLayout()

MPEZoneLayout MPESynthesiserBase::getZoneLayout | ( |  | ) | const
| noexcept

Returns the synthesiser's internal MPE zone layout.

This happens by value, to enforce thread-safety and class invariants.

## ◆ setZoneLayout()

void MPESynthesiserBase::setZoneLayout | ( | MPEZoneLayout | newLayout | ) |

Re-sets the synthesiser's internal MPE zone layout to the one passed in.

As a side effect, this will discard all currently playing notes, call noteReleased for all of them, and disable legacy mode (if previously enabled).

## ◆ setCurrentPlaybackSampleRate()

virtual void MPESynthesiserBase::setCurrentPlaybackSampleRate | ( | double | sampleRate | ) |
| virtual

Tells the synthesiser what the sample rate is for the audio it's being used to render.

Reimplemented in MPESynthesiser.

## ◆ getSampleRate()

double MPESynthesiserBase::getSampleRate | ( |  | ) | const
| noexcept

Returns the current target sample rate at which rendering is being done.

Subclasses may need to know this so that they can pitch things correctly.

## ◆ renderNextBlock()

template<typename floatType >

void MPESynthesiserBase::renderNextBlock | ( | AudioBuffer< floatType > & | outputAudio,
|  | const MidiBuffer & | inputMidi,
|  | int | startSample,
|  | int | numSamples
| ) |  |

Creates the next block of audio output.

Call this to make sound. This will chop up the AudioBuffer into subBlock pieces separated by events in the MIDI buffer, and then call renderNextSubBlock on each one of them. In between you will get calls to noteAdded/Changed/Finished, where you can update parameters that depend on those notes to use for your audio rendering.

Parameters

  outputAudio | Buffer into which audio will be rendered
  inputMidi | MIDI events to process
  startSample | The first sample to process in both buffers
  numSamples | The number of samples to process

## ◆ handleMidiEvent()

virtual void MPESynthesiserBase::handleMidiEvent | ( | const MidiMessage & |  | ) |
| virtual

Handle incoming MIDI events (called from renderNextBlock).

The default implementation provided here simply forwards everything to MPEInstrument::processNextMidiEvent, where it is used to update the MPE notes, zones etc. MIDI messages not relevant for MPE are ignored.

This method can be overridden if you need to do custom MIDI handling on top of MPE. The MPESynthesiser class overrides this to implement callbacks for MIDI program changes and non-MPE-related MIDI controller messages.

Reimplemented in MPESynthesiser.

## ◆ setMinimumRenderingSubdivisionSize()

void MPESynthesiserBase::setMinimumRenderingSubdivisionSize | ( | int | numSamples,
|  | bool | shouldBeStrict = `false`
| ) |  |
| noexcept

Sets a minimum limit on the size to which audio sub-blocks will be divided when rendering.

When rendering, the audio blocks that are passed into renderNextBlock() will be split up into smaller blocks that lie between all the incoming midi messages, and it is these smaller sub-blocks that are rendered with multiple calls to renderVoices().

Obviously in a pathological case where there are midi messages on every sample, then renderVoices() could be called once per sample and lead to poor performance, so this setting allows you to set a lower limit on the block size.

The default setting is 32, which means that midi messages are accurate to about < 1ms accuracy, which is probably fine for most purposes, but you may want to increase or decrease this value for your synth.

If shouldBeStrict is true, the audio sub-blocks will strictly never be smaller than numSamples.

If shouldBeStrict is false (default), the first audio sub-block in the buffer is allowed to be smaller, to make sure that the first MIDI event in a buffer will always be sample-accurate (this can sometimes help to avoid quantisation or phasing issues).

## ◆ enableLegacyMode()

void MPESynthesiserBase::enableLegacyMode | ( | int | pitchbendRange = `2`,
|  | Range< int > | channelRange = `Range< int >(1, 17)`
| ) |  |

Puts the synthesiser into legacy mode.

Parameters

  pitchbendRange | The note pitchbend range in semitones to use when in legacy mode. Must be between 0 and 96, otherwise behaviour is undefined. The default pitchbend range in legacy mode is +/- 2 semitones.
  channelRange | The range of MIDI channels to use for notes when in legacy mode. The default is to use all MIDI channels (1-16).

To get out of legacy mode, set a new MPE zone layout using setZoneLayout.

## ◆ isLegacyModeEnabled()

bool MPESynthesiserBase::isLegacyModeEnabled | ( |  | ) | const
| noexcept

Returns true if the instrument is in legacy mode, false otherwise.

## ◆ getLegacyModeChannelRange()

Range< int > MPESynthesiserBase::getLegacyModeChannelRange | ( |  | ) | const
| noexcept

Returns the range of MIDI channels (1-16) to be used for notes when in legacy mode.

## ◆ setLegacyModeChannelRange()

void MPESynthesiserBase::setLegacyModeChannelRange | ( | Range< int > | channelRange | ) |

Re-sets the range of MIDI channels (1-16) to be used for notes when in legacy mode.

## ◆ getLegacyModePitchbendRange()

int MPESynthesiserBase::getLegacyModePitchbendRange | ( |  | ) | const
| noexcept

Returns the pitchbend range in semitones (0-96) to be used for notes when in legacy mode.

## ◆ setLegacyModePitchbendRange()

void MPESynthesiserBase::setLegacyModePitchbendRange | ( | int | pitchbendRange | ) |

Re-sets the pitchbend range in semitones (0-96) to be used for notes when in legacy mode.

## ◆ setPressureTrackingMode()

void MPESynthesiserBase::setPressureTrackingMode | ( | TrackingMode | modeToUse | ) |

Set the MPE tracking mode for the pressure dimension.

## ◆ setPitchbendTrackingMode()

void MPESynthesiserBase::setPitchbendTrackingMode | ( | TrackingMode | modeToUse | ) |

Set the MPE tracking mode for the pitchbend dimension.

## ◆ setTimbreTrackingMode()

void MPESynthesiserBase::setTimbreTrackingMode | ( | TrackingMode | modeToUse | ) |

Set the MPE tracking mode for the timbre dimension.

## ◆ renderNextSubBlock() [1/2]

virtual void MPESynthesiserBase::renderNextSubBlock | ( | AudioBuffer< float > & | outputAudio,
|  | int | startSample,
|  | int | numSamples
| ) |  |
| protectedpure virtual

Implement this method to render your audio inside.

See also
  renderNextBlock

Implemented in MPESynthesiser.

## ◆ renderNextSubBlock() [2/2]

virtual void MPESynthesiserBase::renderNextSubBlock | ( | AudioBuffer< double > & | ,
|  | int | ,
|  | int |
| ) |  |
| protectedvirtual

Implement this method if you want to render 64-bit audio as well; otherwise leave blank.

Reimplemented in MPESynthesiser.

## Member Data Documentation

## ◆ instrument

MPEInstrument& MPESynthesiserBase::instrument
| protected

The documentation for this struct was generated from the following file:

- juce_MPESynthesiserBase.h